
Global Const TRUE = -1
Global Const FALSE = 0

Type record
    name As String * 20
    number As String * 20
End Type

Global database(100) As record

Global TotalRecords As Integer

Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer

Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer



'  COMM declarations
'
Global Const NOPARITY = 0
Global Const ODDPARITY = 1
Global Const EVENPARITY = 2
Global Const MARKPARITY = 3
Global Const SPACEPARITY = 4

Global Const ONESTOPBIT = 0
Global Const ONE5STOPBITS = 1
Global Const TWOSTOPBITS = 2

Global Const IGNORE = 0          '  Ignore signal
Global Const INFINITE = &HFFFF   '  Infinite timeout

'  Error Flags
Global Const CE_RXOVER = &H1     '  Receive queue overflow
Global Const CE_OVERRUN = &H2    '  Receive overrun error
Global Const CE_RXPARITY = &H4   '  Receive parity error
Global Const CE_FRAME = &H8      '  Receive framing error
Global Const CE_BREAK = &H10     '  Break detected
Global Const CE_CTSTO = &H20     '  CTS timeout
Global Const CE_DSRTO = &H40     '  DSR timeout
Global Const CE_RLSDTO = &H80    '  RLSD timeout
Global Const CE_TXFULL = &H100   '  TX queue is full
Global Const CE_PTO = &H200      '  LPTx timeout
Global Const CE_IOE = &H400      '  LPTx I/O error
Global Const CE_DNS = &H800      '  LPTx device not selected
Global Const CE_OOP = &H1000     '  LPTx out of paper
Global Const CE_MODE = &H8000    '  Requested mode unsupported

Global Const IE_BADID = (-1)     '  Invalid or unsupported ID
Global Const IE_OPEN = (-2)      '  device already open
Global Const IE_NOPEN = (-3)     '  Device not open
Global Const IE_MEMORY = (-4)    '  Unable to allocate queues
Global Const IE_DEFAULT = (-5)   '  Error in default parameters
Global Const IE_HARDWARE = (-10)    '  Hardware not present
Global Const IE_BYTESIZE = (-11)    '  Illegal byte size
Global Const IE_BAUDRATE = (-12)    '  Unsupported baud rate

'  Events
Global Const EV_RXCHAR = &H1     '  Any Character received
Global Const EV_RXFLAG = &H2     '  Received certain character
Global Const EV_TXEMPTY = &H4    '  Transmit queue empty
Global Const EV_CTS = &H8        '  CTS changed state
Global Const EV_DSR = &H10       '  DSR changed state
Global Const EV_RLSD = &H20      '  RLSD changed state
Global Const EV_BREAK = &H40     '  BREAK received
Global Const EV_ERR = &H80       '  Line status error occurred
Global Const EV_RING = &H100     '  Ring signal detected
Global Const EV_PERR = &H200     '  Printer error occurred

'  Escape Functions
Global Const SETXOFF = 1    '  Simulate XOFF received
Global Const SETXON = 2     '  Simulate XON received
Global Const SETRTS = 3     '  Set RTS high
Global Const CLRRTS = 4     '  Set RTS low
Global Const SETDTR = 5     '  Set DTR high
Global Const CLRDTR = 6     '  Set DTR low
Global Const RESETDEV = 7   '  Reset device if possible

Global Const LPTx = &H80    '  Set if ID is for LPT device

Type Dcb
    Id As String * 1
    BaudRate As Integer
    ByteSize As String * 1
    Parity As String * 1
    StopBits As String * 1
    RlsTimeout As Integer
    CtsTimeout As Integer
    DsrTimeout As Integer

    Bits1 As String * 1      ' The fifteen actual DCB bit-sized data
    Bits2 As String * 1      ' fields within these two bytes can be manipulated by
		 ' manipulated by bitwise logical And/Or
		 ' operations. Refer to SDKWIN.HLP for
		 ' location/meaning of specific bits

    XonChar As String * 1
    XoffChar As String * 1
    XonLim As Integer
    XoffLim As Integer
    PeChar As String * 1
    EofChar As String * 1
    EvtChar As String * 1
    TxDelay As Integer
End Type

Type COMSTAT
    Bits As String * 1       ' For specific bit flags and their
		 ' meanings, refer to SDKWIN.HLP
    cbInQue As Integer
    cbOutQue As Integer
End Type

Declare Function OpenComm Lib "User" (ByVal lpComName As String, ByVal wInQueue As Integer, ByVal wOutQueue As Integer) As Integer
Declare Function SetCommState Lib "User" (lpDCB As Dcb) As Integer
Declare Function GetCommState Lib "User" (ByVal nCid As Integer, lpDCB As Dcb) As Integer
Declare Function ReadComm Lib "User" (ByVal nCid As Integer, ByVal lpBuf As String, ByVal nSize As Integer) As Integer
Declare Function UngetCommChar Lib "User" (ByVal nCid As Integer, ByVal cChar As Integer) As Integer
Declare Function WriteComm Lib "User" (ByVal nCid As Integer, ByVal lpBuf As String, ByVal nSize As Integer) As Integer
Declare Function CloseComm Lib "User" (ByVal nCid As Integer) As Integer
Declare Function BuildCommDCB Lib "User" (ByVal lpDef As String, lpDCB As Dcb) As Integer
Declare Function TransmitCommChar Lib "User" (ByVal nCid As Integer, ByVal cChar As Integer) As Integer
Declare Function SetCommEventMask Lib "User" (ByVal nCid As Integer, ByVal nEvtMask As Integer) As Long
Declare Function GetCommEventMask Lib "User" (ByVal nCid As Integer, ByVal nEvtMask As Integer) As Integer
Declare Function SetCommBreak Lib "User" (ByVal nCid As Integer) As Integer
Declare Function ClearCommBreak Lib "User" (ByVal nCid As Integer) As Integer
Declare Function FlushComm Lib "User" (ByVal nCid As Integer, ByVal nQueue As Integer) As Integer
Declare Function EscapeCommFunction Lib "User" (ByVal nCid As Integer, ByVal nFunc As Integer) As Integer





