
Declare Function GetFocus% Lib "USER" ()
Declare Function GetWindowLong& Lib "USER" (ByVal hWnd%, ByVal nIndex%)
Declare Function SetWindowLong& Lib "USER" (ByVal hWnd%, ByVal nIndex%, ByVal dwNewLong&)
Declare Function SendMessage& Lib "USER" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam&)

Const WM_USER = &H400
Const EM_SETPASSWORDCHAR = WM_USER + 28
Const ES_PASSWORD = &H20
Const GWL_STYLE = -16

Global Const SMISTS_USER_CANCEL = 131
Global Const VIM_TEXT = "VIM_TEXT"
Global Const VIMSEL_ATTACH = 6&
Global Const VIMSEL_NATIVE = 55&

Global Const VB_MAXBUFFERSIZE = 2048
Global Const VB_MAXNAMESIZE = 256

Global Const VIM_FALSE = 0
Global Const VIM_TRUE = 1

Global Const VIMSTS_SUCCESS = 0
Global Const VIMSTS_FAILURE = 1
Global Const VIMSTS_FATAL = 2

Global Const VIM_MAIL = "VIM_MAIL"
Global Const VIM_CURRENT_VERSION = 100&
Global Const VIMSEL_CP1252 = 16&
Global Const VIMSEL_PRODUCT = 72&

Declare Function VIMCreateMessage& Lib "VIM.DLL" (ByVal session&, ByVal psType$, pMessage&)
Declare Function VIMCloseMessage& Lib "VIM.DLL" (ByVal Message&)
Declare Function VIMTerminate& Lib "VIM.DLL" ()
Declare Function vb_VIMTerminate& Lib "VIMVBWRP.DLL" ()
Declare Function VIMInitialize& Lib "VIM.DLL" ()
Declare Function VIMOpenSession& Lib "VIM.DLL" (ByVal psPathSpec As Any, ByVal psName As Any, ByVal psPass As Any, ByVal dwVersion&, ByVal selCharSet&, session&)
Declare Function VIMCloseSession& Lib "VIM.DLL" (ByVal session&)
Declare Function VIMGetDefaultSessionInfo& Lib "VIM.DLL" (ByVal sizePath%, ByVal psPathSpec$, ByVal sizeName%, ByVal psName$)
Declare Function VIMQueryCapability& Lib "VIM.DLL" (ByVal selType&, ByVal sizeData%, pData As Any)
Declare Function vb_VIM_STATUS% Lib "VIMVBWRP.DLL" (ByVal L&)
Declare Function vb_VIM_EXT_STATUS% Lib "VIMVBWRP.DLL" (ByVal L&)


Global Const SMISTS_SUCCESS = 0
Global Const SMISTS_FAILURE = 1

Global Const SMI_TO = 1
Global Const SMI_CC = 2
Global Const SMI_BCC = 3

Global Const SMI_UNKNOWN = 0
Global Const SMI_PERSON = 1
Global Const SMI_GROUP = 2

Global Const SMI_PRIVATE = "(SMI_PRIVATE)"
Global Const SMI_PUBLIC = "(SMI_PUBLIC)"

Global Const SMI_UI = &H1
Global Const SMI_ARRAYS_IN_STRUCTS = &H2

Type smiRecipArrayDesc
   RecipClass As Long
   NameType As Long
   Name As String * 1024
   AddressBook As String * 256
   Address As String * 1024
End Type
 
Type smiFileArrayDesc
    PathName As String * 256
    FileName As String * 256
    FileType As String * 256
End Type

Type vb_vimBuffFileDesc     ' File Buffer Descriptor.  Fix size Buffer and FileName
   Size As Long             ' Buffer size or number of bytes to read
                            ' MUST BE ZERO if FileName is used
   Buffer As String * VB_MAXBUFFERSIZE
   Offset As Long           ' Starting offset at which to start
   FileName As String * VB_MAXNAMESIZE  ' File name string
End Type

Type vimBuffFileDesc
    Size As Long
    Buffer As Long      ' A void pointer To be allocated
    Offset As Long
    FileName As Long    ' A void pointer to be allocated
End Type

Global bufffiledesc As vb_vimBuffFileDesc

Declare Function VIMSetMessageItem& Lib "VIM.DLL" (ByVal Message&, ByVal selClass&, ByVal strType$, ByVal selFlags&, ByVal strName As Any, pDesc As vimBuffFileDesc)
Declare Function vb_VIMSetMessageItem& Lib "VIMVBWRP.DLL" (ByVal Message&, ByVal selClass&, ByVal strType$, ByVal selFlags&, ByVal strName As Any, pDesc As vb_vimBuffFileDesc)

Declare Function SMISendDocuments& Lib "SMI.DLL" (ByVal dwUIParam&, ByVal strPath$, ByVal strFilenames$, ByVal strDelim$, ByVal dwReserved&)

Declare Function SMISendMail& Lib "SMI.DLL" (ByVal dwUIParam&, ByVal nRecipCount&, pRecips As Any, ByVal nFileCount&, pFiles As Any, psSubject As Any, psNoteText As Any, psMessageType As Any, ByVal fFlags&, ByVal dwReserved&)

' ************************************************************************
' The following declarations come from SMIEXT.H that comes with Lotus
' VIM Developer's Toolkit.  Please ignore these declarations for other
' VIM implementations
'
Global Const SMI_NO_FLAGS = &H0&

' long SMIAPIENTRY SMIAddressAndSend(  long int dwUIParam,
'                             void SMI_FAR * SMI_PTR msg,
'                             long int dwReserved );
Declare Function SMIAddressAndSend& Lib "SMI.DLL" (ByVal dwUIParam&, ByVal Msg&, ByVal dwReserved&)

' ************************************************************************


Global szPath As String * 1024
Global szName As String * 255
Global szPassword As String * 255
Global cancel As Integer
Global session As Long

Sub CloseSession (ByVal session&)
' PURPOSE:  this subroutine closes the session
' RECEIVE:
'   session - the handle of session to be closed (by reference)
' REMARKS
'   Will set the session handle to be zero after closing the session.
'   This prevents usage of session after being closed.

    Dim vimSts As Long
    
    vimSts = VIMCloseSession(session)
    If vimSts <> VIMSTS_SUCCESS Then
        MsgBox "Error closing session.  Status = " + Str$(vimSts)
        End
    Else
        session = 0       'reset session to NULL after close
    End If
End Sub

Function OpenSession& (session&)
' PURPOSE:  this function gets the default session information and attempts
'           to open a session.
' Receives:
'   session& - Handle for a openned session (by reference)
' RETURNS:  error status code.
' REMARKS:  Assume Form2 to be the login form

    Dim vimSts As Long
    Dim selCharSet As Long
    Dim Msg As String

    selCharSet = VIMSEL_CP1252
    'vimSts = VIMGetDefaultSessionInfo(Len(szPath$), ByVal szPath$, Len(szName$), ByVal szName$)
    'Stop
    If vimSts <> VIMSTS_SUCCESS Then
        MsgBox "VIM Deffault Session Error. Code = " + Str$(vimSts)
        End
    Else
        'Form2.Show 1
        vimSts = VIMOpenSession(ByVal szPath$, ByVal szName$, ByVal szPassword$, VIM_CURRENT_VERSION, ByVal selCharSet&, session&)
    End If
   
    If vimSts <> VIMSTS_SUCCESS Then
      Msg$ = "Error opening the session." + " Status = " + Str$(vimSts)
      MsgBox Msg$
      End
    End If

    OpenSession = vimSts

End Function

Function trim_null (st As String) As String
    st$ = LTrim$(RTrim$(st$))
    end_st$ = Mid(st$, Len(st$), 1)
    If Asc(end_st$) = 0 Then
        st$ = Mid$(st$, 1, Len(st$) - 1)
    End If
    trim_null = st$
End Function

Sub TrimNullStr (given$)
    Dim I As Integer
    I = InStr(given, Chr$(0))
    If I Then given$ = Left$(given$, I - 1)
End Sub

