Option Explicit

  ' CONSTANTS
    '
    ' System Menu Constants
    '
      Global Const MF_SEPARATOR = &H800
      Global Const MF_STRING = &H0
      Global Const MF_ENABLED = 0
      Global Const MF_BYCOMMAND = &H0
      Global Const MF_UNCHECKED = &H0
      Global Const MF_CHECKED = &H8
      Global Const MF_BYPOSITION = &H400
      Global Const MF_GRAYED = &H1
    
      Global Const SC_CLOSE = 6 'by position
    '
    ' Windows Message Constants
    '
      Global Const WM_QUERYOPEN = &H13    'restore minimized window message
      Global Const WM_SYSCOMMAND = &H112  'system command message

  ' API CALLS
    '
    ' System Menu API Declarations
    '
      '
      ' Append or Remove menu items
      '
        Declare Function AppendMenu Lib "USER" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any) As Integer
        Declare Function RemoveMenu Lib "USER" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer) As Integer
      '
      ' Get System Menu handle
      '
        Declare Function GetSystemMenu Lib "USER" (ByVal hWnd As Integer, ByVal bRevert As Integer) As Integer
      '
      ' Get the state of and modify System Menu items. Used to check and
      ' uncheck menu items
      '
        Declare Function GetMenuState Lib "USER" (ByVal hMenu As Integer, ByVal wId As Integer, ByVal wFlags As Integer) As Integer
        Declare Function ModifyMenuBystring Lib "USER" Alias "ModifyMenu" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpString As String) As Integer

Function IsSysMenuChecked (ByVal frmhWnd As Integer, ByVal MenuId As Integer) As Integer
 '
 '  See if System Menu Item is checked or not
 '
 Dim iResult As Integer, hMenu As Integer
 hMenu% = GetSystemMenu(frmhWnd, False)
 iResult% = GetMenuState(hMenu, MenuId%, MF_BYCOMMAND)
 If iResult% = MF_CHECKED Then
   IsSysMenuChecked% = True
 Else
   IsSysMenuChecked% = False
 End If
End Function

Sub SetupDialogMenu (ByVal frmhWnd As Integer)
  Dim hMenu As Integer, iResult As Integer
  hMenu% = GetSystemMenu(frmhWnd%, 0)
  '
  ' Remove all but the MOVE and CLOSE options. Note that
  ' the min and max buttons are assumed to be set to
  ' false and the form's BorderStyle is assumed to be
  ' fixed double.
  '
  iResult% = RemoveMenu(hMenu, 8, MF_BYPOSITION) 'Switch to
  iResult% = RemoveMenu(hMenu, 7, MF_BYPOSITION) 'Separator
  iResult% = RemoveMenu(hMenu, 5, MF_BYPOSITION) 'Separator
End Sub

Sub SysMenuBuild (ByVal frmhWnd As Integer, SysMenuItems() As String)
 '
 ' Add Additional Menu Strings to System Menu
 '
 Dim hMenu As Integer, Result As Integer, i As Integer, MenuId As Integer
 hMenu% = GetSystemMenu(frmhWnd, False)
 
 MenuId% = 1
 For i% = LBound(SysMenuItems) To UBound(SysMenuItems)
    If SysMenuItems(i%) Like "-" Then
        Result% = AppendMenu(hMenu%, MF_SEPARATOR, 0, "")
    Else
        Result% = AppendMenu(hMenu%, MF_STRING, MenuId%, SysMenuItems(i%))
        MenuId% = MenuId% + 1
    End If
 Next i%
End Sub

Sub SysMenuCheck (ByVal frmhWnd As Integer, ByVal MenuId As Integer, iStatus As Integer)
  '
  ' Place checkmark on or remove checkmark from hard coded menu item.
  '
  Dim iResult As Integer, hMenu As Integer
  hMenu = GetSystemMenu(frmhWnd, False)
  If iStatus% = MF_UNCHECKED Then
    iResult% = ModifyMenuBystring(hMenu, 6, MF_UNCHECKED Or MF_BYPOSITION, MenuId%, "&Toolbox On Top")
  Else
    iResult% = ModifyMenuBystring(hMenu, 6, MF_CHECKED Or MF_BYPOSITION, MenuId%, "&Toolbox On Top")
  End If
End Sub

Sub SysMenuDisable (ByVal frmhWnd As Integer, ByVal MenuId As Integer)
    Dim iResult As Integer, hMenu As Integer

    hMenu = GetSystemMenu(frmhWnd, False)

    iResult% = ModifyMenuBystring(hMenu, MenuId%, MF_BYPOSITION Or MF_GRAYED, MenuId%, "&Close" + Chr$(9) + "Ctrl+F4")
End Sub

