DECLARE SUB AlterCentralDirectory (FileName$, CentralDirectory AS ANY)
DECLARE SUB AlterLocalFile (FileName$, LocalFileHeader AS ANY)
DECLARE FUNCTION MSDOSDate2STRDate$ (AA$)
DECLARE FUNCTION MSDOSTime2STRTime$ (AA$)
DECLARE FUNCTION STRDate2MSDOSDate$ (AA$)
DECLARE FUNCTION STRTime2MSDOSTime$ (AA$)
DECLARE FUNCTION UnsignedInt& (AA$)
DECLARE FUNCTION UnsignedWORD# (AA$)
DECLARE SUB ReadZip ()
DECLARE SUB AlterLocalFileZip (FileName$, LocalFileHeader AS ANY)
DEFINT A-Z

TYPE LocalfileHeadertype
    versionneededtoextract  AS STRING * 2
    generalpurposebitflag   AS STRING * 2
    compressionmethod       AS STRING * 2
    lastmodfiletime         AS STRING * 2
    lastmodfiledate         AS STRING * 2
    crc32                   AS STRING * 4
    compressedsize          AS STRING * 4
    uncompressedsize        AS STRING * 4
    filenamelength          AS STRING * 2
    ExtraFieldLength        AS STRING * 2
END TYPE

TYPE CentraldirectoryType
    versionmadeby               AS STRING * 2
    versionneededtoextract      AS STRING * 2
    generalpurposebitflag       AS STRING * 2
    compressionmethod           AS STRING * 2
    lastmodfiletime             AS STRING * 2
    lastmodfiledate             AS STRING * 2
    crc32                       AS STRING * 4
    compressedsize              AS STRING * 4
    uncompressedsize            AS STRING * 4
    filenamelength              AS STRING * 2
    ExtraFieldLength            AS STRING * 2
    Filecommentlength           AS STRING * 2
    disknumberstart             AS STRING * 2
    internalfileattributes      AS STRING * 2
    externalfileattributes      AS STRING * 4
    relativeoffsetoflocalheader AS STRING * 4
END TYPE

TYPE EndOFCentraldirectoryType
    Numberofthisdisk                       AS STRING * 2
    Numofdiskwithstartofcentraldirectory   AS STRING * 2
    totalentriesincentraldironthisdisk     AS STRING * 2
    totalentriesincentraldir               AS STRING * 2
    sizeofcentraldir                       AS STRING * 4
    offsetofstartofcentraldirectory        AS STRING * 4
    ZipfilecommentLength                   AS STRING * 2
END TYPE

'Complete zip file layout can be found in APPNOTE.TXT, as distributed
'by PKWARE

'OPTION EXPLICIT

CALL ReadZip

SUB AlterCentralDirectory (FileName$, CentralDirectory AS CentraldirectoryType)

PRINT FileName$, MSDOSDate2STRDate$(CentralDirectory.lastmodfiledate), MSDOSTime2STRTime$(CentralDirectory.lastmodfiletime)

END SUB

SUB AlterLocalFile (FileName$, LocalFileHeader AS LocalfileHeadertype)

PRINT FileName$, MSDOSDate2STRDate$(LocalFileHeader.lastmodfiledate), MSDOSTime2STRTime$(LocalFileHeader.lastmodfiletime)

END SUB

FUNCTION MSDOSDate2STRDate$ (AA$)


'--------------------------------
'First get the year

DIM DateInt&
DateInt& = UnsignedInt&(AA$)

DIM FourDigitYr%
FourDigitYr% = (DateInt& \ 512) + 1980


DIM FormattedYear$
FormattedYear$ = "19" + RIGHT$("0" + LTRIM$(STR$(FourDigitYr%)), 2)


'--------------------------------
'Now the month

DateInt& = DateInt& - (FourDigitYr% - 1980) * 512


DIM TwoDigitMonth%
TwoDigitMonth% = (DateInt& \ 32)

DIM FormattedMonth$
FormattedMonth$ = RIGHT$("0" + LTRIM$(STR$(TwoDigitMonth%)), 2)


'--------------------------------
'Now the day

DateInt& = DateInt& - TwoDigitMonth% * 32

DIM TwoDigitDay%
TwoDigitDay% = DateInt&

DIM FormattedDay$
FormattedDay$ = RIGHT$("0" + LTRIM$(STR$(TwoDigitDay%)), 2)


'--------------------------------
'Put it all together

MSDOSDate2STRDate$ = FormattedMonth$ + "-" + FormattedDay$ + "-" + FormattedYear$

END FUNCTION

FUNCTION MSDOSTime2STRTime$ (AA$)

'--------------------------------
'First get the hour

DIM TimeInt&
TimeInt& = UnsignedInt&(AA$)

DIM TwoDigitHour%
TwoDigitHour% = TimeInt& \ 2048

DIM FormattedHour$
FormattedHour$ = RIGHT$("0" + LTRIM$(STR$(TwoDigitHour%)), 2)


'--------------------------------
'Now get the minutes

TimeInt& = TimeInt& - (TwoDigitHour% * 2048&)

DIM TwoDigitMinutes%
TwoDigitMinutes% = (TimeInt& \ 32)

DIM FormattedMinutes$
FormattedMinutes$ = RIGHT$("0" + LTRIM$(STR$(TwoDigitMinutes%)), 2)


'--------------------------------
'Now get the seconds

TimeInt& = TimeInt& - TwoDigitMinutes% * 32

DIM TwoDigitSeconds%
TwoDigitSeconds% = TimeInt& * 2

DIM FormattedSeconds$
FormattedSeconds$ = RIGHT$("0" + LTRIM$(STR$(TwoDigitSeconds%)), 2)


'--------------------------------
'Now put it all togeter

MSDOSTime2STRTime$ = FormattedHour$ + "." + FormattedMinutes$ + "." + FormattedSeconds$

END FUNCTION

SUB ReadZip

DIM headersignature       AS STRING * 4
DIM LocalFileHeader       AS LocalfileHeadertype
DIM CentralDirectory      AS CentraldirectoryType
DIM EndOFCentraldirectory AS EndOFCentraldirectoryType

DIM ZipBuf%
ZipBuf% = FREEFILE


CLS
OPEN "test.zip" FOR BINARY AS ZipBuf%

'get 1st header
DIM CurByte&
CurByte& = 1

GET #ZipBuf%, CurByte&, headersignature
CurByte& = CurByte& + LEN(headersignature)

PRINT "---------------------------------------read local file headers"
DO WHILE headersignature = "PK"       '0x04034b50
    GET #ZipBuf%, CurByte&, LocalFileHeader

    LocalFileHeader.lastmodfiledate = STRDate2MSDOSDate$(DATE$)
    LocalFileHeader.lastmodfiletime = STRTime2MSDOSTime$("12.00.00")
    PUT #ZipBuf%, CurByte&, LocalFileHeader

    CurByte& = CurByte& + LEN(LocalFileHeader)

    DIM TempFilenameLength&
    TempFilenameLength& = UnsignedInt&(LocalFileHeader.filenamelength)

    DIM FileName$
    FileName$ = SPACE$(TempFilenameLength&)
    GET #ZipBuf%, , FileName$
    CurByte& = CurByte& + LEN(FileName$)


    DIM ExtraFieldLength&
    ExtraFieldLength& = UnsignedInt&(LocalFileHeader.ExtraFieldLength)
    DIM TempExtraField$
    TempExtraField$ = SPACE$(ExtraFieldLength&)
    GET #ZipBuf%, , TempExtraField$
    CurByte& = CurByte& + LEN(TempExtraField$)


    DIM TempCompressedSize#
    TempCompressedSize# = UnsignedWORD#(LocalFileHeader.compressedsize)
    CurByte& = CurByte& + TempCompressedSize#


    CALL AlterLocalFile(FileName$, LocalFileHeader)


    'get next file name
    GET #ZipBuf%, CurByte&, headersignature
    CurByte& = CurByte& + LEN(headersignature)
LOOP

PRINT "---------------------------------------read central directory"
DO WHILE headersignature = "PK" + CHR$(1) + CHR$(2)   '0x02014b50
    GET #ZipBuf%, CurByte&, CentralDirectory

    CentralDirectory.lastmodfiledate = STRDate2MSDOSDate$(DATE$)
    CentralDirectory.lastmodfiletime = STRTime2MSDOSTime$("12.00.00")
    PUT #ZipBuf%, CurByte&, CentralDirectory

    CurByte& = CurByte& + LEN(CentralDirectory)

    TempFilenameLength& = UnsignedInt&(CentralDirectory.filenamelength)
    FileName$ = SPACE$(TempFilenameLength&)
    GET #ZipBuf%, , FileName$
    CurByte& = CurByte& + LEN(FileName$)


    ExtraFieldLength& = UnsignedInt&(CentralDirectory.ExtraFieldLength)
    TempExtraField$ = SPACE$(ExtraFieldLength&)
    GET #ZipBuf%, , TempExtraField$
    CurByte& = CurByte& + LEN(TempExtraField$)


    DIM Filecommentlength&
    Filecommentlength& = UnsignedInt&(CentralDirectory.Filecommentlength)
    DIM Filecomment$
    Filecomment$ = SPACE$(Filecommentlength&)
    GET #ZipBuf%, , Filecomment$
    CurByte& = CurByte& + LEN(Filecomment$)

    CALL AlterCentralDirectory(FileName$, CentralDirectory)

    'get next file name
    GET #ZipBuf%, CurByte&, headersignature
    CurByte& = CurByte& + LEN(headersignature)
LOOP

PRINT "---------------------------------------read end-of-central directory record"
IF headersignature = "PK" THEN      '0x06054b50
    
    GET #ZipBuf%, CurByte&, EndOFCentraldirectory
    CurByte& = CurByte& + LEN(EndOFCentraldirectory)

    DIM ZipfilecommentLength&
    ZipfilecommentLength& = UnsignedInt&(EndOFCentraldirectory.ZipfilecommentLength)
    DIM Zipfilecomment$
    Zipfilecomment$ = SPACE$(ZipfilecommentLength&)
    GET #ZipBuf%, , Zipfilecomment$

END IF

CLOSE #ZipBuf%


END SUB

FUNCTION STRDate2MSDOSDate$ (AA$)
' MM-DD-YYYY format for AA$

DIM TwoDigitMonth%
TwoDigitMonth% = VAL(LEFT$(AA$, 2))

DIM TwoDigitDay%
TwoDigitDay% = VAL(MID$(AA$, 4, 2))

DIM FourDigitYr%
FourDigitYr% = VAL(RIGHT$(AA$, 4))

DIM Temp&
Temp& = (FourDigitYr% - 1980) * 512 + (TwoDigitMonth% * 32) + TwoDigitDay%

DIM High&
High& = Temp& \ 256

DIM Low&
Low& = Temp& - High& * 256

DIM HighByte$
HighByte$ = CHR$(High&)

DIM LowByte$
LowByte$ = CHR$(Low&)

STRDate2MSDOSDate$ = LowByte$ + HighByte$

END FUNCTION

FUNCTION STRTime2MSDOSTime$ (AA$)
'hh.mm.ss

DIM TwoDigitHour%
TwoDigitHour% = VAL(LEFT$(AA$, 2))

DIM TwoDigitMinutes%
TwoDigitMinutes% = VAL(MID$(AA$, 4, 2))

DIM TwoDigitSeconds%
TwoDigitSeconds% = VAL(MID$(AA$, 7))

DIM Temp&
Temp& = (TwoDigitHour% * 2048&) + TwoDigitMinutes% * 32 + (TwoDigitSeconds% \ 2)

DIM High&
High& = Temp& \ 256

DIM Low&
Low& = Temp& - High& * 256

DIM HighByte$
HighByte$ = CHR$(High&)

DIM LowByte$
LowByte$ = CHR$(Low&)

STRTime2MSDOSTime$ = LowByte$ + HighByte$


END FUNCTION

FUNCTION UnsignedInt& (AA$)

DIM Value&

Value& = ASC(RIGHT$(AA$, 1)) * 256&
Value& = Value& + ASC(LEFT$(AA$, 1))

UnsignedInt& = Value&

END FUNCTION

DEFINT A-Z
FUNCTION UnsignedWORD# (AA$)

DIM Value#

Value# = ASC(MID$(AA$, 4, 1)) * 256# * 256# * 256#
Value# = Value# + ASC(MID$(AA$, 3, 1)) * 256# * 256#
Value# = Value# + ASC(MID$(AA$, 2, 1)) * 256#
Value# = Value# + ASC(MID$(AA$, 1, 1))

UnsignedWORD# = Value#

END FUNCTION

